/* digiclock (C) 2001 by Ge0rG
   Ach ja, dieses Programm unterliegt der GPL, also nix klauen ;o)

Revision history

2001-09-24	first release
	some functions

2001-09-25	0.02 (first real version number
	you can give the path to the bmp's as parameter now


HOWTO for own skins (german):
----
Fr alle, die mehr wollen, als nur den Standard-Font:

Erstellt mit eurem Lieblingsmalprogramm 10 Bilder (#.bmp) mit je 17x32 Pixel
und 2 Farben (monochrom) fr die Ziffern, und zwei Bilder fr den Punkt (p.bmp)
und den Doppelpunkt (dp.bmp), die 9x32 Pixel gross sind.

Wenn Ihr eurer Kreativitt freien Lauf gelassen habt, msstet Ihr jetzt 12
BMP-Dateien (0.bmp bis 9.bmp, p.bmp und dp.bmp) haben. Diese mssen auf die
dbox (am besten in ein eigenes Verzeichnis) kopiert werden. Wenn Ihr auch
das geschafft habt, knnt ihr nun digiclock starten:

digiclock /verzeichnis/mit/den/bildern

Wenn Ihr die Bilder nach /var/tmp/dc/ kopiert habt, startet Ihr also:

digiclock /var/tmp/dc
----
This HOWTO can be copied and redistributed separetly from the source, if
an author remark is placed before or after it.
*/

#include <fcntl.h>
#include <time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>

#include "bmp.h"
//#include "../../bmp2raw/raw.h"

#include "liblcd.h"


#define CW 17
#define DPW 9

typedef unsigned char digit_packed[4][CW];

digit_packed digits[10], p, dp;

void read_digit(digit_packed d, char *filename) {
	FILE *fbmp, *fraw;
	struct bmp_header bh;
	struct bmp_color *colors;
	long int line_size, bmpline_size, image_size;
	unsigned char *image;

	lcd_raw_buffer raw;
	lcd_packed_buffer s;

	int i;

	printf("[digiclock] reading %s...\n", filename);
	if ((fbmp = fopen(filename, "r"))==NULL) {
		perror("fopen(BMP_FILE)");
		exit(2);
	}
	if (fread(&bh, 1, sizeof(bh), fbmp)!=sizeof(bh)) {
		perror("fread(BMP_HEADER)");
		exit(3);
	}
	if ((bh._B!='B')||(bh._M!='M')) {
		fprintf(stderr, "Bad Magic (not a BMP file).\n");
		exit(4);
	}

	bh_ntoh(&bh);

	// 4 * 2^bit_count
	colors = malloc(4<<bh.bit_count);
	if (fread(colors, 1, 4<<bh.bit_count, fbmp)!=4<<bh.bit_count) {
		perror("fread(BMP_COLORS)");
		exit(5);
	}

	// image
	line_size = (bh.width*bh.bit_count / 8);
	bmpline_size = (line_size + 3) & ~3;
	image_size = bmpline_size*bh.height;

	image = malloc(image_size);
	if (fread(image, 1, image_size, fbmp)!=image_size) {
		perror("fread(BMP_IMAGE)");
		exit(6);
	}
	fclose(fbmp);
	
	memset(raw, 0, sizeof(raw));
	bmp2raw(bh, colors, image, raw);
	free(image);
	free(colors);
	raw2packed(raw, s);

	for (i=0; i<4; i++) memcpy(&d[i], s[i], CW);
}


void show_digit(int x, int y, digit_packed d, int width, lcd_packed_buffer s) {
	int i;

	for (i=0; i<4; i++) memcpy(&s[i+y][x], d[i], width);
}

void show_int(int x, int y, int i, lcd_packed_buffer s) {
	show_digit(x, y, digits[i/10], CW, s);
	show_digit(x+CW, y, digits[i%10], CW, s);
}


void render_clock(lcd_packed_buffer s) {
        char timestr[50];
        struct timeb tb;
        struct tm *t;
	int bla, x, y, si, co;
        ftime(&tb);
	t = localtime(&tb.time);

	memset(s, 0, LCD_BUFFER_SIZE);

	show_int(0, 0, t->tm_mday, s);
	show_digit(2*CW, 0, p, DPW, s);
	show_int(2*CW+DPW, 0, t->tm_mon+1, s);
	show_digit(4*CW+DPW, 0, p, DPW, s);
	show_int(4*CW+2*DPW, 0, t->tm_year%100, s);

	show_int(0, 4, t->tm_hour, s);
	show_digit(2*CW, 4, dp, DPW, s);
	show_int(2*CW+DPW, 4, t->tm_min, s);
	show_digit(4*CW+DPW, 4, dp, DPW, s);
	show_int(4*CW+2*DPW, 4, t->tm_sec, s);
}

int main(int argc, char *args[]) {
	int lcd_fd, i;
	char buf[256], path[256];
	lcd_packed_buffer screen;

	printf("digiclock 0.02 (C) Georg Lukas <georg@boerde.de> [tuxbox project]\n");
	printf("   arts design (C) bbfan <bbfan1@gmx.de>\n\n");

	if (argc > 1) {
		strncpy(path, args[1], 255);
	} else strcpy(path, "dc");

	for (i=0; i<10; i++) {
		snprintf(buf, 255, "%s/%i.bmp", path, i);
		read_digit(digits[i], buf);
	}
	snprintf(buf, 255, "%s/p.bmp", path); read_digit(p, buf);
	snprintf(buf, 255, "%s/dp.bmp", path); read_digit(dp, buf);

	lcd_fd = lcd_open();

	while (1) {
		render_clock(screen);
		lcd_write(lcd_fd, screen);
		sleep(1);
	}
	lcd_close(lcd_fd);
	return 0;
}
