/* lcdlib.h (C) 2001 Georg Lukas <georg@boerde.de>; linux dbox2 project */

#ifndef __liblcd__
#define __liblcd__

#include "lcd-ks0713.h"

/* DEPRECATED compatibility typedef - should not be used */
typedef unsigned char screen_t[LCD_BUFFER_SIZE];

#ifndef __raw__
typedef unsigned char lcd_raw_buffer[64][120];
typedef unsigned char lcd_packed_buffer[8][120];
#endif

/* returns file handle or sets errno if ret_val<0 */
int lcd_open();

/* sets text mode on LCD, closes file */
int lcd_close(int lcd_fd);

/* clears the LCD screen */
int lcd_clr(int lcd_fd);

/* draws a packed buffer to the LCD */
int lcd_write(int lcd_fd, lcd_packed_buffer s);

/* set/clear/invert a pixel in a packed buffer */
void lcd_putpixel(int x, int y, char col, lcd_packed_buffer s);

#endif // __liblcd__
